<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">

<head>
  <title>Phonon.Experimental.AudioDataOutput</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <link rel="stylesheet" type="text/css" href="../common/doxygen.css" />
  <link rel="stylesheet" media="screen" type="text/css" title="KDE Colors" href="../common/kde.css" />
</head>
<body>
<div id="container">
<div id="header">
  <div id="header_top">
    <div>
      <div>
        <img alt ="" src="../common/top-kde.jpg"/>
        KDE 4.2 PyKDE API Reference
      </div>
    </div>
  </div>
  <div id="header_bottom">
    <div id="location">
      <ul>
        <li>KDE's Python API</li>
      </ul>
    </div>

    <div id="menu">
      <ul>
        <li><a href="../modules.html">Overview</a></li>
<li><a href="http://techbase.kde.org/Development/Languages/Python">PyKDE Home</a></li>
<li><a href="http://kde.org/family/">Sitemap</a></li>
<li><a href="http://kde.org/contact/">Contact Us</a></li>
</ul>
    </div>
  </div>
</div>

<div id="body_wrapper">
<div id="body">
<div id="right">
<div class="content">
<div id="main">
<div class="clearer">&nbsp;</div>

<h1>AudioDataOutput Class Reference</h1>
<code>from PyKDE4.phonon import *</code>
<p>


Namespace: Phonon::Experimental<br />
<h2>Detailed Description</h2>

<p>This class gives you the audio data (for visualizations).
</p>
<p>
This class implements a special AbstractAudioOutput that gives your
application the audio data. Don't expect realtime performance. But
the latencies should be low enough to use the audio data for
visualizations. You can also use the audio data for further processing
(e.g. encoding and saving to a file).
</p>
<p>
The class supports different data formats. One of the most common formats
is to read vectors of integers (which will only use 16 Bit), but you can
also request floats which some backends use internally.
</p>
<p>

<dl class="author" compact><dt><b>Author:</b></dt><dd> Matthias Kretz &lt;kretz@kde.org&gt; </dd></dl>
</p>
<table border="0" cellpadding="0" cellspacing="0"><tr><td colspan="2"><br><h2>Enumerations</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="#obj178829196">Channel</a>&nbsp;</td><td class="memItemRight" valign="bottom">{&nbsp;LeftChannel, RightChannel, CenterChannel, LeftSurroundChannel, RightSurroundChannel, SubwooferChannel&nbsp;}</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="#obj198587084">Format</a>&nbsp;</td><td class="memItemRight" valign="bottom">{&nbsp;IntegerFormat, FloatFormat&nbsp;}</td></tr>
<tr><td colspan="2"><br><h2>Signals</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj172666700">dataReady</a> (QMap<Phonon::Experimental::AudioDataOutput::Channel,QVector<qint16>> data)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj195355724">dataReady</a> (QMap<Phonon::Experimental::AudioDataOutput::Channel,QVector<float>> data)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj197760972">endOfMedia</a> (int remainingSamples)</td></tr>
<tr><td colspan="2"><br><h2>Methods</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj186540172">__init__</a> (self, Phonon.Experimental.AudioDataOutput other)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj172666700">dataReady</a> (self, QMap<Phonon::Experimental::AudioDataOutput::Channel,QVector<qint16>> data)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj195355724">dataReady</a> (self, QMap<Phonon::Experimental::AudioDataOutput::Channel,QVector<float>> data)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj172666796">dataSize</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj197760972">endOfMedia</a> (self, int remainingSamples)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">Phonon.Experimental.AudioDataOutput.Format&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj178830956">format</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj178827948">sampleRate</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj170797580">setDataSize</a> (self, int size)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj178830540">setFormat</a> (self, Phonon.Experimental.AudioDataOutput.Format format)</td></tr>
</table>
<hr><h2>Method Documentation</h2><a class="anchor" name="obj186540172"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">__init__</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">Phonon.Experimental.AudioDataOutput&nbsp;</td>
<td class="paramname"><em>other</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj172666700"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> dataReady</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">QMap<Phonon::Experimental::AudioDataOutput::Channel,QVector<qint16>>&nbsp;</td>
<td class="paramname"><em>data</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Emitted whenever another dataSize number of samples are ready and
format is set to IntegerFormat.
</p>
<p>
If format is set to FloatFormat the signal is not emitted at all.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>data</em>&nbsp;</td><td> A mapping of Channel to a vector holding the audio data.
</td></tr>
</table></dl>
<p>
</p><dl compact><dt><b>Signal syntax:</b></dt><dd><code>QObject.connect(source, SIGNAL("dataReady(const QMap<Phonon::Experimental::AudioDataOutput::Channel,QVector<qint16>>&)"), target_slot)</code></dd></dl></div></div><a class="anchor" name="obj195355724"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> dataReady</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">QMap<Phonon::Experimental::AudioDataOutput::Channel,QVector<float>>&nbsp;</td>
<td class="paramname"><em>data</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Emitted whenever another dataSize number of samples are ready and
format is set to FloatFormat.
</p>
<p>
If format is set to IntegerFormat the signal is not emitted at all.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>data</em>&nbsp;</td><td> A mapping of Channel to a vector holding the audio data.
</td></tr>
</table></dl>
<p>
</p><dl compact><dt><b>Signal syntax:</b></dt><dd><code>QObject.connect(source, SIGNAL("dataReady(const QMap<Phonon::Experimental::AudioDataOutput::Channel,QVector<float>>&)"), target_slot)</code></dd></dl></div></div><a class="anchor" name="obj172666796"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">int dataSize</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Returns the currently used number of samples passed through
the signal.
</p>
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd> setDataSize
</dd></dl>
</p></div></div><a class="anchor" name="obj197760972"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> endOfMedia</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">int&nbsp;</td>
<td class="paramname"><em>remainingSamples</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>This signal is emitted before the last dataReady signal of a
media is emitted.
</p>
<p>
If, for example, the playback of a media file has finished and the
last audio data of that file is going to be passed with the next
dataReady signal, and only the 28 first samples of the data
vector are from that media file endOfMedia will be emitted right
before dataReady with <b>remainingSamples</b> = 28.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>remainingSamples</em>&nbsp;</td><td> The number of samples in the next
dataReady vector that belong to the media that was playing to
this point.
</td></tr>
</table></dl>
<p>
</p><dl compact><dt><b>Signal syntax:</b></dt><dd><code>QObject.connect(source, SIGNAL("endOfMedia(int)"), target_slot)</code></dd></dl></div></div><a class="anchor" name="obj178830956"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">Phonon.Experimental.AudioDataOutput.Format format</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Returns the currently used format.
</p>
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd> setFormat
</dd></dl>
</p></div></div><a class="anchor" name="obj178827948"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">int sampleRate</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Returns the sample rate in Hz. Common sample rates are 44100 Hz
and 48000 Hz. AudioDataOutput will not do any sample rate
conversion for you. If you need to convert the sample rate you
might want to take a look at libsamplerate. For visualizations it
is often enough to do simple interpolation or even drop/duplicate
samples.
</p>
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd> The sample rate as reported by the backend. If the
backend is unavailable -1 is returned.
</dd></dl>
</p></div></div><a class="anchor" name="obj170797580"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setDataSize</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">int&nbsp;</td>
<td class="paramname"><em>size</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Sets the number of samples to be passed in one signal emission.
</p>
<p>
Defaults to 512 samples per emitted signal.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>size</em>&nbsp;</td><td> the number of samples
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj178830540"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setFormat</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">Phonon.Experimental.AudioDataOutput.Format&nbsp;</td>
<td class="paramname"><em>format</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Requests the dataformat you'd like to receive. Only one of the
signals of this class will be emitted when new data is ready.
</p>
<p>
The default format is IntegerFormat.
</p>
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd> format()
</dd></dl>
</p></div></div><hr><h2>Enumeration Documentation</h2><a class="anchor" name="obj178829196"></a>
<div class="memitem">
<div class="memproto">
<table class="memname">
<tr><td class="memname">Channel</td>
</tr>
</table>
</div>
<div class="memdoc"><p>Specifies the channel the audio data belongs to.
</p><dl compact><dt><b>Enumerator: </b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0"><tr><td valign="top"><em>LeftChannel</em>&nbsp;</td><td><tr><td valign="top"><em>RightChannel</em>&nbsp;</td><td><tr><td valign="top"><em>CenterChannel</em>&nbsp;</td><td><tr><td valign="top"><em>LeftSurroundChannel</em>&nbsp;</td><td><tr><td valign="top"><em>RightSurroundChannel</em>&nbsp;</td><td><tr><td valign="top"><em>SubwooferChannel</em>&nbsp;</td><td></table>
</dl>
</div></div><p><a class="anchor" name="obj198587084"></a>
<div class="memitem">
<div class="memproto">
<table class="memname">
<tr><td class="memname">Format</td>
</tr>
</table>
</div>
<div class="memdoc"><p>Requests 16 bit signed integers.
</p>
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd> dataReady(const QVector&lt;qint16&gt; &amp;)
</dd></dl>
</p><dl compact><dt><b>Enumerator: </b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0"><tr><td valign="top"><em>IntegerFormat</em>&nbsp;=&nbsp;1</td><td><tr><td valign="top"><em>FloatFormat</em>&nbsp;=&nbsp;2</td><td></table>
</dl>
</div></div><p>
</div>
</div>
</div>

<div id="left">

<div class="menu_box">
<div class="nav_list">
<ul>
<li><a href="../allclasses.html">Full Index</a></li>
</ul>
</div>

<a name="cp-menu" /><div class="menutitle"><div>
  <h2 id="cp-menu-project">Modules</h2>
</div></div>
<div class="nav_list">
<ul>
<li><a href="../akonadi/index.html">akonadi</a></li>
<li><a href="../dnssd/index.html">dnssd</a></li>
<li><a href="../kdecore/index.html">kdecore</a></li>
<li><a href="../kdeui/index.html">kdeui</a></li>
<li><a href="../khtml/index.html">khtml</a></li>
<li><a href="../kio/index.html">kio</a></li>
<li><a href="../knewstuff/index.html">knewstuff</a></li>
<li><a href="../kparts/index.html">kparts</a></li>
<li><a href="../kutils/index.html">kutils</a></li>
<li><a href="../nepomuk/index.html">nepomuk</a></li>
<li><a href="../phonon/index.html">phonon</a></li><li><a href="../plasma/index.html">plasma</a></li>
<li><a href="../solid/index.html">solid</a></li>
<li><a href="../soprano/index.html">soprano</a></li>
</ul></div></div>

</div>

</div>
  <div class="clearer"/>
</div>

<div id="end_body"></div>
</div>
<div id="footer"><div id="footer_text">
This documentation is maintained by <a href="&#109;&#97;&#105;&#108;&#116;&#111;&#58;simon&#64;simonzone&#46;com">Simon Edwards</a>.<br />
        KDE<sup>&#174;</sup> and <a href="../images/kde_gear_black.png">the K Desktop Environment<sup>&#174;</sup> logo</a> are registered trademarks of <a href="http://ev.kde.org/" title="Homepage of the KDE non-profit Organization">KDE e.V.</a> |
        <a href="http://www.kde.org/contact/impressum.php">Legal</a>
    </div></div>
</body>
</html>
